Index: /java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/communication/ClientSideManagedConnection.java	(revision 98)
@@ -176,4 +176,5 @@
 
 	private <C> void sendImplementation(Request request, Dispatcher<C> dispatcher, ClientSideResponseFuture callback) {
+		callback.setRequest(request);
 
 		if (getState().ordinal() > JoinableState.RUNNING.ordinal()) {
Index: /java/main/src/main/java/com/framsticks/communication/ClientSideResponseFuture.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ClientSideResponseFuture.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/communication/ClientSideResponseFuture.java	(revision 98)
@@ -11,4 +11,6 @@
 	}
 
+	protected Request request;
+
 	protected abstract void processOk(Response response);
 
@@ -18,7 +20,21 @@
 			processOk(response);
 		} else {
-			handle(new FramsticksException().msg("invalid response").arg("comment", response.getComment()));
+			handle(new FramsticksException().msg("invalid response").arg("comment", response.getComment()).arg("request", request));
 		}
 	}
 
+	/**
+	 * @return the request
+	 */
+	public Request getRequest() {
+		return request;
+	}
+
+	/**
+	 * @param request the request to set
+	 */
+	public void setRequest(Request request) {
+		this.request = request;
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/communication/Request.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/Request.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/communication/Request.java	(revision 98)
@@ -48,5 +48,6 @@
 	@Override
 	public String toString() {
-		return getCommand() + " request";
+		// return getCommand();
+		return "request " + stringRepresentation();
 	}
 
Index: /java/main/src/main/java/com/framsticks/communication/RequestHandler.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/RequestHandler.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/communication/RequestHandler.java	(revision 98)
@@ -2,9 +2,10 @@
 
 import com.framsticks.communication.queries.ApplicationRequest;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 
 /**
  * @author Piotr Sniegowski
  */
-public interface RequestHandler {
+public interface RequestHandler extends ExceptionResultHandler {
 	public void handle(ApplicationRequest request, ServerSideResponseFuture responseCallback);
 }
Index: /java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/communication/ServerSideManagedConnection.java	(revision 98)
@@ -12,5 +12,4 @@
 import java.net.Socket;
 import com.framsticks.util.dispatching.RunAt;
-import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
 /**
@@ -21,5 +20,5 @@
 	private final static Logger log = Logger.getLogger(ServerSideManagedConnection.class);
 
-	RequestHandler requestHandler;
+	protected final RequestHandler requestHandler;
 
 	public ServerSideManagedConnection(Socket socket, RequestHandler requestHandler) {
@@ -70,6 +69,5 @@
 
 	protected final void respond(final Response response, final Integer id) {
-		//TODO TEH: pass it the hosted tree
-		senderThread.dispatch(new RunAt<Connection>(ThrowExceptionHandler.getInstance()) {
+		senderThread.dispatch(new RunAt<Connection>(requestHandler) {
 			@Override
 			protected void runAt() {
Index: /java/main/src/main/java/com/framsticks/communication/Subscription.java
===================================================================
--- /java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/communication/Subscription.java	(revision 98)
@@ -73,5 +73,4 @@
 
 	public void dispatchCall(final List<File> files) {
-		//TODO TEH
 		Dispatching.dispatchIfNotActive(dispatcher, new RunAt<C>(ThrowExceptionHandler.getInstance()) {
 			@Override
Index: /java/main/src/main/java/com/framsticks/core/AbstractTree.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/core/AbstractTree.java	(revision 98)
@@ -1,5 +1,3 @@
 package com.framsticks.core;
-import java.util.HashSet;
-import java.util.Set;
 
 import javax.annotation.Nonnull;
@@ -10,10 +8,18 @@
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
-import com.framsticks.params.Param;
 import com.framsticks.params.ParamsPackage;
 import com.framsticks.params.Registry;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.Dispatcher;
 import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableDispatcher;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
 import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.dispatching.Thread;
@@ -24,18 +30,39 @@
  */
 @FramsClassAnnotation
-public abstract class AbstractTree extends Thread<Tree> implements Tree {
+public abstract class AbstractTree extends AbstractJoinable implements Dispatcher<Tree>, Tree, JoinableParent {
 
 	private static final Logger log = Logger.getLogger(Tree.class);
 
-	private Node root;
-
-	@Override
-	public void setRoot(Node node) {
-		root = node;
-	}
-
-	@Override
-	public @Nonnull Node getRoot() {
-		assert root != null;
+	private Node root = null;
+	private ExceptionResultHandler handler = ThrowExceptionHandler.getInstance();
+
+	private JoinableDispatcher<Tree> dispatcher;
+
+	@Override
+	public void assignRootParam(CompositeParam param) {
+		if (root != null) {
+			throw new FramsticksException().msg("root has already specified type");
+		}
+		root = new Node(this, param, null);
+		log.info("assigned root type: " + root);
+	}
+
+	@Override
+	public void assignRootObject(Object object) {
+		if (root == null) {
+			throw new FramsticksException().msg("root is has no type specified");
+		}
+		if (root.getObject() != null) {
+			throw new FramsticksException().msg("root has already object assigned").arg("current", root.getObject()).arg("candidate", object);
+		}
+		root = new Node(this, root.getParam(), object);
+		log.info("assigned root object: " + root);
+	}
+
+	@Override
+	public @Nonnull Node getAssignedRoot() {
+		if (root == null) {
+			throw new FramsticksException().msg("root has no type specified yet");
+		}
 		return root;
 	}
@@ -46,8 +73,8 @@
 	}
 
-	protected Set<TreeListener> listeners = new HashSet<TreeListener>();
+	protected String name;
 
 	public AbstractTree() {
-		setName("entity");
+		setName("tree");
 	}
 
@@ -55,59 +82,4 @@
 
 	}
-
-
-	protected void fireRun(Exception e) {
-		for (TreeListener l : this.listeners) {
-			l.onRun(e);
-		}
-	}
-
-	protected void fireStop(Exception e) {
-		for (TreeListener l : this.listeners) {
-			l.onStop(e);
-		}
-	}
-
-	@Override
-	public void addListener(final TreeListener listener) {
-		assert Dispatching.isThreadSafe();
-		Dispatching.dispatchIfNotActive(this, new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
-			@Override
-			protected void runAt() {
-				listeners.add(listener);
-			}
-		});
-	}
-
-	@Override
-	public void removeListener(final TreeListener listener) {
-		assert Dispatching.isThreadSafe();
-		Dispatching.dispatchIfNotActive(this, new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
-			@Override
-			protected void runAt() {
-				listeners.remove(listener);
-			}
-		});
-	}
-
-	protected void fireListChange(Path path, ListChange change) {
-		assert isActive();
-		for (TreeListener l : this.listeners) {
-			l.onListChange(path, change);
-		}
-	}
-
-	@Override
-	public void notifyOfFetch(Path path) {
-		fireFetch(path);
-	}
-
-	protected void fireFetch(Path path) {
-		assert isActive();
-		for (TreeListener l : this.listeners) {
-			l.onFetch(path);
-		}
-	}
-
 
 	@Override
@@ -142,16 +114,4 @@
 	}
 
-	@Override
-	protected void joinableStart() {
-		dispatch(new RunAt<Tree>(ThrowExceptionHandler.getInstance()) {
-			@Override
-			protected void runAt() {
-				if (!isRootAssigned()) {
-					setRoot(new Node(Param.build().name("Tree").id(getName()).type("o").finish(CompositeParam.class), null));
-				}
-			}
-		});
-		super.joinableStart();
-	}
 
 	@Override
@@ -159,4 +119,108 @@
 		registry.putFramsClass(framclass);
 	}
+
+
+	/**
+	 * @return the handler
+	 */
+	@Override
+	public ExceptionResultHandler getExceptionHandler() {
+		return handler;
+	}
+
+	/**
+	 * @param handler the handler to set
+	 */
+	@Override
+	public void setExceptionHandler(ExceptionResultHandler handler) {
+		this.handler = handler;
+	}
+
+	@Override
+	public void handle(FramsticksException exception) {
+		handler.handle(exception);
+	}
+
+	/**
+	 * @return the dispatcher
+	 */
+	@Override
+	public JoinableDispatcher<Tree> getDispatcher() {
+		return dispatcher;
+	}
+
+	/**
+	 * @param dispatcher the dispatcher to set
+	 */
+	@Override
+	public void setDispatcher(JoinableDispatcher<Tree> dispatcher) {
+		if (this.dispatcher != null) {
+			throw new FramsticksException().msg("dispatcher is already set").arg("tree", this).arg("dispatcher", dispatcher);
+		}
+		this.dispatcher = dispatcher;
+	}
+
+	/**
+	 * @return the name
+	 */
+	@ParamAnnotation
+	public String getName() {
+		return name;
+	}
+
+	/**
+	 * @param name the name to set
+	 */
+	@ParamAnnotation
+	public void setName(String name) {
+		this.name = name;
+	}
+
+	@Override
+	protected void joinableStart() {
+		if (dispatcher == null) {
+			dispatcher = new Thread<Tree>();
+		}
+		Dispatching.use(dispatcher, this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(dispatcher, this);
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(dispatcher);
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		if (joinable == dispatcher) {
+			proceedToState(state);
+		}
+	}
+
+	@Override
+	public boolean isActive() {
+		if (dispatcher == null) {
+			throw new FramsticksException().msg("no dispatcher is set for tree yet").arg("tree", this);
+		}
+		return dispatcher.isActive();
+	}
+
+	@Override
+	public void dispatch(RunAt<? extends Tree> runnable) {
+		if (dispatcher == null) {
+			throw new FramsticksException().msg("no dispatcher is set for tree yet").arg("tree", this);
+		}
+		dispatcher.dispatch(runnable);
+	}
+
 }
 
Index: /java/main/src/main/java/com/framsticks/core/Node.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Node.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/core/Node.java	(revision 98)
@@ -5,5 +5,7 @@
 
 import com.framsticks.params.CompositeParam;
-import com.framsticks.params.ParamBuilder;
+import com.framsticks.util.FramsticksException;
+// import com.framsticks.params.ParamBuilder;
+import com.framsticks.util.lang.Strings;
 
 /**
@@ -13,21 +15,19 @@
 public class Node {
 
+	protected final Tree tree;
 	protected final CompositeParam param;
 	protected final Object object;
-	//protected final Map<String, Node> children = new HashMap<String, Node>();
 
-	public Node() {
-		param = null;
-		object = null;
-	}
-
-	public Node(@Nonnull CompositeParam param, Object object) {
+	public Node(Tree tree, @Nonnull CompositeParam param, Object object) {
 		assert param != null;
+		assert tree != null;
+		this.tree = tree;
 		this.param = param;
 		this.object = object;
 	}
 
-	public Node(@Nonnull ParamBuilder builder, Object object) {
-		this(builder.finish(CompositeParam.class), object);
+
+	public final Tree getTree() {
+		return tree;
 	}
 
@@ -40,3 +40,19 @@
 	}
 
+	@Override
+	public String toString() {
+		return param.toString() + ":" + Strings.toStringNullProof(object, "<null>");
+	}
+
+	public final boolean isResolved() {
+		return object != null;
+	}
+
+	public Node assureResolved() {
+		if (!isResolved()) {
+			throw new FramsticksException().msg("path is not resolved").arg("node", this);
+		}
+		return this;
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/core/ObjectTree.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/ObjectTree.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/core/ObjectTree.java	(revision 98)
@@ -8,10 +8,11 @@
 import com.framsticks.params.Param;
 import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ValueParam;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
-import com.framsticks.util.UnsupportedOperationException;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.Future;
+
 import static com.framsticks.core.TreeOperations.*;
 
@@ -24,9 +25,10 @@
 		registry.registerAndBuild(object.getClass());
 		AccessInterface access = registry.createAccess(object.getClass());
-		setRoot(new Node(Param.build().forAccess(access).id(getName()).finish(CompositeParam.class), object));
+		assignRootParam(Param.build().forAccess(access).id(getName()).finish(CompositeParam.class));
+		assignRootObject(object);
 	}
 
 	public Object getRootObject() {
-		return getRoot().getObject();
+		return getAssignedRoot().getObject();
 	}
 
@@ -43,15 +45,15 @@
 
 	@Override
-	public void get(final Path path, Mode mode, Future<Object> future) {
+	public void get(Path path, Mode mode, Future<Path> future) {
 		assert isActive();
 		log.debug("requesting: " + path);
-		fireFetch(path);
-		future.pass(path.getTopObject());
+		path = resolveTopSync(path);
+		future.pass(path);
 	}
 
 	@Override
-	public void get(Path path, PrimitiveParam<?> param, Mode mode, Future<Object> future) {
+	public void get(Path path, ValueParam param, Mode mode, Future<Object> future) {
 		assert isActive();
-		fireFetch(path);
+		path = resolveTopSync(path);
 		future.pass(bindAccess(path).get(param, Object.class));
 	}
@@ -80,20 +82,18 @@
 	}
 
-	@Override
-	public void resolve(Path path, Future<Path> future) {
+	protected Path resolveTopSync(Path path) {
 		assert isActive();
 		assert path.isOwner(this);
 		if (path.getTop().getObject() != null) {
-			future.pass(path);
-			return;
+			return path;
 		}
-		AccessInterface access = bindAccess(this, path.getUnder());
+		AccessInterface access = bindAccess(path.getUnder());
 		Object object = access.get(path.getTop().getParam(), Object.class);
 		if (object == null) {
-			future.pass(path);
-			return;
+			return path;
 		}
-		future.pass(path.appendResolution(object));
+		return path.appendResolution(object);
 	}
+
 
 	@Override
@@ -103,10 +103,3 @@
 	}
 
-	@Override
-	public Path create(Path path) {
-		assert isActive();
-		assert !path.isResolved();
-		throw new UnsupportedOperationException();
-	}
-
 }
Index: /java/main/src/main/java/com/framsticks/core/Path.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Path.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/core/Path.java	(revision 98)
@@ -58,5 +58,5 @@
 	public Path appendParam(CompositeParam param) {
 		assert isResolved();
-		return appendNode(new Node(param, null));
+		return appendNode(new Node(tree, param, null));
 	}
 
@@ -99,5 +99,5 @@
 		public PathBuilder setLast(Object object) {
 			Node n = nodes.pollLast();
-			nodes.add(new Node(n.getParam(), object));
+			nodes.add(new Node(n.getTree(), n.getParam(), object));
 			return this;
 		}
@@ -130,4 +130,5 @@
 		}
 
+
 		public PathBuilder resolve(@Nonnull Tree tree, String textual) {
 
@@ -136,14 +137,11 @@
 			this.tree = tree;
 
-			nodes.add(tree.getRoot());
-			Node current = tree.getRoot();
+			Node current = tree.getAssignedRoot();
+			nodes.add(current);
 
 			StringBuilder b = new StringBuilder();
 			Iterator<String> i = splitPath(textual);
 			while (i.hasNext() && current.getObject() != null) {
-				AccessInterface access = tree.prepareAccess(current.getParam());
-				if (access == null) {
-					break;
-				}
+				AccessInterface access = TreeOperations.bindAccess(current);// tree.prepareAccess(current.getParam());
 				String e = i.next();
 				Param p = access.getParam(e);
@@ -155,5 +153,5 @@
 				b.append("/").append(e);
 				access.select(current.getObject());
-				current = new Node(c, getKnownChild(tree, access, c));
+				current = new Node(current.getTree(), c, getKnownChild(tree, access, c));
 				nodes.add(current);
 			}
@@ -218,4 +216,9 @@
 		assert Dispatching.isThreadSafe();
 		return this.textual.equals(textual);
+	}
+
+	public final boolean isTheSameTextually(Path path) {
+		assert Dispatching.isThreadSafe();
+		return (tree == path.getTree()) && textual.equals(path.getTextual());
 	}
 
@@ -242,5 +245,5 @@
 			return Path.build().resolve(tree, "/").finish();
 		}
-		Object child = getKnownChild(tree, TreeOperations.bindAccess(tree, getUnder()), getTop().getParam());
+		Object child = getKnownChild(tree, TreeOperations.bindAccess(getUnder()), getTop().getParam());
 		if (child == null) {
 			return this;
@@ -249,18 +252,4 @@
 	}
 
-	public boolean matches(Path p) {
-		assert Dispatching.isThreadSafe();
-		assert tree == p.tree;
-		Iterator<Node> a = nodes.iterator();
-		Iterator<Node> b = p.nodes.iterator();
-		while (a.hasNext() && b.hasNext()) {
-			Node an = a.next();
-			Node bn = b.next();
-			if (an.object != bn.object) {
-				return false;
-			}
-		}
-		return a.hasNext() == b.hasNext();
-	}
 
 	public String getLastElement() {
@@ -278,8 +267,9 @@
 	}
 
-	public void assureResolved() {
+	public Path assureResolved() {
 		if (!isResolved()) {
 			throw new FramsticksException().msg("path is not resolved").arg("path", this);
 		}
+		return this;
 	}
 
@@ -287,4 +277,30 @@
 		return Path.build().resolve(tree, textual).finish();
 	}
+
+	public boolean isTheSameObjects(Path path) {
+		if (tree != path.getTree()) {
+			return false;
+		}
+		if (size() != path.size()) {
+			return false;
+		}
+		if (!getTextual().equals(path.getTextual())) {
+			return false;
+		}
+		Iterator<Node> a = nodes.iterator();
+		Iterator<Node> b = path.getNodes().iterator();
+		while (a.hasNext()) {
+			assert b.hasNext();
+			if (a.next() != b.next()) {
+				return false;
+			}
+		}
+		return true;
+	}
+
+
+	// public boolean isEmpty() {
+	// 	return nodes.isEmpty();
+	// }
 }
 
Index: /java/main/src/main/java/com/framsticks/core/Tree.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/Tree.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/core/Tree.java	(revision 98)
@@ -8,21 +8,20 @@
 import com.framsticks.params.PrimitiveParam;
 import com.framsticks.params.Registry;
+import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableDispatcher;
 
-public interface Tree extends Dispatcher<Tree>, Joinable {
+public interface Tree extends Dispatcher<Tree>, Joinable, ExceptionResultHandler {
 
-	public @Nonnull Node getRoot();
-	public @Nonnull void setRoot(Node node);
+	public @Nonnull Node getAssignedRoot();
+	public void assignRootParam(CompositeParam param);
+	public void assignRootObject(Object object);
 
 	public @Nonnull AccessInterface prepareAccess(CompositeParam param);
 	public void takeAllFrom(Registry source);
-
-	public void addListener(TreeListener listener);
-	public void removeListener(TreeListener listener);
-
-	public void notifyOfFetch(Path path);
 
 	public FramsClass getInfoFromCache(String id);
@@ -30,16 +29,31 @@
 	public void putInfoIntoCache(FramsClass framclass);
 
-	public void resolve(Path path, Future<Path> future);
+	/**
+	 *
+	 * Functions accepts ValueParam, because it is also possible to get number of List elements.
+	 *
+	 */
+	public void get(Path path, ValueParam param, Mode mode, Future<Object> future);
 
-	public void get(Path path, PrimitiveParam<?> param, Mode mode, Future<Object> future);
-
-	public void get(Path path, Mode mode, Future<Object> future);
+	public void get(Path path, Mode mode, Future<Path> future);
 
 	public void call(Path path, ProcedureParam param, Object[] arguments, Future<Object> future);
 
+	/**
+	 *
+	 * Functions accepts PrimitiveParam<?>, because it is not possible to set number of List elements.
+	 *
+	 */
 	public void set(Path path, PrimitiveParam<?> param, Object value, Future<Integer> future);
 
 	public void info(Path path, Future<FramsClass> future);
 
-	public Path create(Path path);
+	public void setExceptionHandler(ExceptionResultHandler handler);
+
+	public ExceptionResultHandler getExceptionHandler();
+
+	public void setDispatcher(JoinableDispatcher<Tree> dispatcher);
+
+	public JoinableDispatcher<Tree> getDispatcher();
+
 }
Index: /java/main/src/main/java/com/framsticks/core/TreeOperations.java
===================================================================
--- /java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 98)
@@ -1,3 +1,4 @@
 package com.framsticks.core;
+
 
 import java.util.List;
@@ -14,5 +15,4 @@
 import com.framsticks.params.Param;
 import com.framsticks.params.PrimitiveParam;
-import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.ObjectParam;
 import com.framsticks.params.types.ProcedureParam;
@@ -28,5 +28,5 @@
 public final class TreeOperations {
 
-	private static final Logger log = Logger.getLogger(TreeOperations.class.getName());
+	private static final Logger log = Logger.getLogger(TreeOperations.class);
 
 	private TreeOperations() {
@@ -36,16 +36,69 @@
 		assert tree.isActive();
 		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
-		if ("/".equals(file.getPath())) {
-			if (tree.getRoot().getParam().getContainedTypeName() == null) {
-				tree.setRoot(new Node(Param.build().name("Tree").id(tree.getName()).type("o " + framsClass.getId()).finish(CompositeParam.class), tree.getRoot().getObject()));
-			}
-		}
+		log.debug("process fetched info for " + tree + ": " + framsClass);
 		tree.putInfoIntoCache(framsClass);
 		return framsClass;
 	}
 
+	public static void processFetchedValues(Path path, List<File> files) {
+		Tree tree = path.getTree();
+		assert tree.isActive();
+		assert files.size() == 1;
+		assert path.isTheSame(files.get(0).getPath());
+
+		if (!path.isResolved()) {
+			AccessInterface access = tree.prepareAccess(path.getTop().getParam());
+			Object child = access.createAccessee();
+			assert child != null;
+			if (path.size() == 1) {
+				tree.assignRootObject(child);
+			} else {
+				bindAccess(path.getUnder()).set(path.getTop().getParam(), child);
+			}
+			path = path.appendResolution(child);
+		}
+
+		log.debug("process fetched values: " + path);
+		Node node = path.getTop();
+		MultiParamLoader loader = new MultiParamLoader();
+		loader.setNewSource(files.get(0).getContent());
+		loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
+
+		try {
+			if (node.getParam() instanceof ObjectParam) {
+				loader.addAccessInterface(bindAccess(node));
+				loader.go();
+				return;
+			}
+
+			ListAccess listAccess = (ListAccess) bindAccess(node);
+			listAccess.clearValues();
+
+			AccessInterface elementAccess = listAccess.getElementAccess();
+			loader.addAccessInterface(elementAccess);
+			MultiParamLoader.Status status;
+			while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
+				if (status == MultiParamLoader.Status.AfterObject) {
+					AccessInterface accessInterface = loader.getLastAccessInterface();
+
+					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
+					//TODO listAccessParam
+					CompositeParam param = Param.build().forAccess(accessInterface).id(id).finish(CompositeParam.class);
+					Object child = accessInterface.getSelected();
+					accessInterface.select(null);
+					assert child != null;
+					bindAccess(node).set(param, child);
+				}
+			}
+
+		} catch (FramsticksException e) {
+			throw new FramsticksException().msg("exception occurred while loading").cause(e);
+		}
+	}
+
 	public static FramsClass getInfo(Path path) {
 		Tree tree = path.getTree();
 		assert tree.isActive();
+		log.debug("get info for: " + path);
 		final String name = path.getTop().getParam().getContainedTypeName();
 		return tree.getInfoFromCache(name);
@@ -53,4 +106,5 @@
 
 	public static void findInfo(final Path path, final Future<FramsClass> future) {
+		log.debug("find info for: " + path);
 		try {
 			Tree tree = path.getTree();
@@ -67,117 +121,13 @@
 	}
 
-	public static void processFetchedValues(Path path, List<File> files) {
-		Tree tree = path.getTree();
-		assert tree.isActive();
-		assert files.size() == 1;
-		assert path.isTheSame(files.get(0).getPath());
-		Node node = path.getTop();
-		MultiParamLoader loader = new MultiParamLoader();
-		loader.setNewSource(files.get(0).getContent());
-		loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
-
-		try {
-			if (node.getParam() instanceof ObjectParam) {
-				loader.addAccessInterface(TreeOperations.bindAccess(tree, node));
-				loader.go();
-				tree.notifyOfFetch(path);
-				return;
-			}
-
-			ListAccess listAccess = ((ListAccess) TreeOperations.bindAccess(tree, node));
-			assert listAccess != null;
-			listAccess.clearValues();
-
-			AccessInterface elementAccess = listAccess.getElementAccess();
-			loader.addAccessInterface(elementAccess);
-			MultiParamLoader.Status status;
-			while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
-				if (status == MultiParamLoader.Status.AfterObject) {
-					AccessInterface accessInterface = loader.getLastAccessInterface();
-
-					String id = listAccess.computeIdentifierFor(accessInterface.getSelected());
-					//TODO listAccessParam
-					Param param = Param.build().forAccess(accessInterface).id(id).finish();
-					Object child = accessInterface.getSelected();
-					accessInterface.select(null);
-					assert child != null;
-					TreeOperations.bindAccess(tree, node).set((ValueParam) param, child);
-				}
-			}
-
-			tree.notifyOfFetch(path);
-		} catch (Exception e) {
-			log.error("exception occurred while loading: " + e);
-		}
-
-	}
-
-	public static void resolveAndGet(final Tree tree, final String targetPath, final Future<Path> future) {
-		resolve(tree, targetPath, new FutureHandler<Path>(future) {
-			@Override
-			protected void result(final Path path) {
-				assert path.isResolved(targetPath);
-				//TODO Future
-				tree.get(path, Mode.FETCH, new FutureHandler<Object>(future) {
-					@Override
-					protected void result(Object object) {
-						future.pass(path);
-					}
-				});
-			}
-		});
-	}
-
-
-	public static void resolve(final Path path, final Future<Path> future) {
-		final Tree tree = path.getTree();
-		assert tree.isActive();
-		if (path.getTop().getObject() != null) {
-			if (getInfoFromCache(path) != null) {
-				future.pass(path);
-				return;
-			}
-			TreeOperations.findInfo(path, new FutureHandler<FramsClass>(future) {
-				@Override
-				protected void result(FramsClass result) {
-					future.pass(path);
-				}
-			});
-			return;
-		}
-		TreeOperations.findInfo(path, new FutureHandler<FramsClass>(future) {
-			@Override
-			protected void result(FramsClass result) {
-				assert tree.isActive();
-				assert path.getTop().getParam().isMatchingContainedName(result.getId());
-				Path p = (path.getTop().getParam().getContainedTypeName() != null ? path : path.tryFindResolution());
-				future.pass(TreeOperations.createIfNeeded(p));
-			}
-		});
-	}
-
-	public static Path createIfNeeded(Tree tree, String path) {
-		assert tree.isActive();
-		Path p;
-		while (!(p = Path.to(tree, path)).isResolved(path)) {
-			tree.create(p);
-		}
-		return p;
-	}
-
-	public static Path createIfNeeded(Path path) {
-		Tree tree = path.getTree();
-		assert tree.isActive();
-		if (path.isResolved()) {
-			return path;
-		}
-		return tree.create(path);
-	}
+
 
 	public static @Nonnull AccessInterface bindAccess(Tree tree, String path) {
+		log.debug("bind access for textual: " + path + " in " + tree);
 		return bindAccess(Path.to(tree, path));
 	}
 
-	public static @Nonnull AccessInterface bindAccess(Tree tree, Node node) {
+	public static @Nonnull AccessInterface bindAccess(Node node) {
+		Tree tree = node.getTree();
 		assert tree.isActive();
 		assert node.getObject() != null;
@@ -194,5 +144,6 @@
 		assert path.getTree().isActive();
 		path.assureResolved();
-		return bindAccess(path.getTree(), path.getTop());
+		log.debug("bind access for: " + path);
+		return bindAccess(path.getTop());
 	}
 
@@ -219,19 +170,22 @@
 	}
 
+
 	/** This might not be correct. */
-	public static void resolve(final Tree tree, final String targetPath, final Future<Path> future) {
+	public static void tryGet(final Tree tree, final String targetPath, final Future<Path> future) {
+		log.debug("resolve textual: " + targetPath + " for " + tree);
 		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
 
 			@Override
 			protected void runAt() {
-				tree.resolve(Path.to(tree, targetPath), new FutureHandler<Path>(future) {
+				final Path path = Path.to(tree, targetPath);
+				if (path.isResolved()) {
+					future.pass(path);
+					return;
+				}
+
+				tree.get(path, Mode.FETCH, new FutureHandler<Path>(future) {
 					@Override
 					protected void result(Path result) {
-						assert result.getTree().isActive();
-						if (result.isResolved(targetPath)) {
-							future.pass(result);
-							return;
-						}
-						resolve(tree, targetPath, future);
+						tryGet(tree, targetPath, future);
 					}
 				});
